﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.IO;
using System.Threading;
using System.Diagnostics;
using System.Windows.Media;

using Styx;
using Styx.Helpers;
using Styx.Plugins;
using Styx.Common;
using Styx.CommonBot;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;


namespace ReadyCheck
{
    public class ReadyCheck : HBPlugin
    {
        public override string Name { get { return "ReadyCheck"; } }
        public override string Author { get { return "Giwin"; } }		// Modified by Powa
        public override Version Version { get { return new Version(1, 1); } }
        public override bool WantButton { get { return true; } }
        public static LocalPlayer Me = StyxWoW.Me;

        public override void Initialize()
        {
            Lua.Events.AttachEvent("READY_CHECK", Ready);
			Lua.Events.AttachEvent("LFG_PROPOSAL_SHOW", AcceptLFG);
			Lua.Events.AttachEvent("RESURRECT_REQUEST", AcceptRes);
            Logging.Write(Colors.Tomato, "ReadyCheck - Loaded Version " + Version);
        }

        public override void Pulse()
        {

        }
		
		public void AcceptRes(object sender, LuaEventArgs args)
		{	if(!Me.IsDead)
				return;
            Logging.Write(Colors.Tomato, "[ReadyCheck]: Resurrect menu detected, accepting in 15 sec");
			PauseMilli(15000);
            Lua.DoString("AcceptResurrect()");
		}
		
		public void AcceptLFG(object sender, LuaEventArgs args)
		{
            Logging.Write(Colors.Tomato, "[ReadyCheck]: LFG menu detected, accepting in 5 sec");
			PauseMilli(5000);
            Lua.DoString("AcceptProposal()");
		}
		
        public void Ready(object sender, LuaEventArgs args)
        {
		
            Logging.Write(Colors.Tomato, "[ReadyCheck]: Ready Check menu detected, clicking Ready in 5 seconds");
			PauseMilli(5000);
            Lua.DoString("RunMacroText(\"/click ReadyCheckFrameYesButton\");");
        }
		
		 public static void PauseMilli(int howLong)
        {
            Stopwatch myTimer = new Stopwatch();
            Random rnd = new Random();

            myTimer.Restart();

            int length = rnd.Next(howLong, howLong + 2000);

            while (myTimer.ElapsedMilliseconds <= length);     //do nothing
            
            myTimer.Stop();
                 
        }
        
    }
}